"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "build", {
    enumerable: true,
    get: function() {
        return build;
    }
});
var _promises = require("fs/promises");
var _path = require("path");
var _codegen = require("./codegen");
var _parseappdir = require("./parse-appdir");
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g;
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
function build(_) {
    return _build.apply(this, arguments);
}
function _build() {
    _build = _async_to_generator(function(param) {
        var basePath, _ref, _ref1, _isDirectory, baseAppDir, _isDirectory1, srcAppDir, startDir, appDir, urls, _tmp, code;
        return _ts_generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    basePath = param.basePath;
                    // Remove trailing slash from basePath
                    basePath = basePath.replace(/\/$/, "");
                    return [
                        4,
                        (0, _promises.stat)((0, _path.join)(process.cwd(), "app")).catch(function(_) {
                            return null;
                        })
                    ];
                case 1:
                    baseAppDir = (_isDirectory = (_ref = _state.sent()) === null || _ref === void 0 ? void 0 : _ref.isDirectory()) !== null && _isDirectory !== void 0 ? _isDirectory : false;
                    return [
                        4,
                        (0, _promises.stat)((0, _path.join)(process.cwd(), "src", "app")).catch(function(_) {
                            return null;
                        })
                    ];
                case 2:
                    srcAppDir = (_isDirectory1 = (_ref1 = _state.sent()) === null || _ref1 === void 0 ? void 0 : _ref1.isDirectory()) !== null && _isDirectory1 !== void 0 ? _isDirectory1 : false;
                    if (!srcAppDir && !baseAppDir) {
                        return [
                            2,
                            console.log("Could not find app or src/app directory")
                        ];
                    }
                    startDir = baseAppDir ? (0, _path.join)(process.cwd(), "app") : (0, _path.join)(process.cwd(), "src", "app");
                    return [
                        4,
                        (0, _parseappdir.parseDir)(startDir, null, {
                            type: "static",
                            value: basePath
                        })
                    ];
                case 3:
                    appDir = _state.sent();
                    if (!appDir) return [
                        3,
                        5
                    ];
                    return [
                        4,
                        (0, _parseappdir.getApiPaths)(appDir)
                    ];
                case 4:
                    _tmp = _state.sent();
                    return [
                        3,
                        6
                    ];
                case 5:
                    _tmp = [];
                    _state.label = 6;
                case 6:
                    urls = _tmp;
                    code = (0, _codegen.codegen)(urls, startDir);
                    return [
                        4,
                        (0, _promises.writeFile)((0, _path.join)(startDir, "next-typed-api-client.ts"), code, {
                            encoding: "utf-8"
                        })
                    ];
                case 7:
                    _state.sent();
                    return [
                        4,
                        modifyGitignore()
                    ];
                case 8:
                    _state.sent();
                    console.log("Generated next-typed-api-client.ts");
                    return [
                        2
                    ];
            }
        });
    });
    return _build.apply(this, arguments);
}
function modifyGitignore() {
    return _modifyGitignore.apply(this, arguments);
}
function _modifyGitignore() {
    _modifyGitignore = _async_to_generator(function() {
        var gitignorePath, gitignore, error;
        return _ts_generator(this, function(_state) {
            switch(_state.label){
                case 0:
                    _state.trys.push([
                        0,
                        4,
                        ,
                        5
                    ]);
                    gitignorePath = (0, _path.join)(process.cwd(), ".gitignore");
                    return [
                        4,
                        (0, _promises.readFile)(gitignorePath, {
                            encoding: "utf-8"
                        })
                    ];
                case 1:
                    gitignore = _state.sent();
                    if (!!gitignore.includes("next-typed-api-client.ts")) return [
                        3,
                        3
                    ];
                    return [
                        4,
                        (0, _promises.writeFile)(gitignorePath, gitignore + "\n\n# Added by next-typed-api automatically\nnext-typed-api-client.ts\n", {
                            encoding: "utf-8"
                        })
                    ];
                case 2:
                    _state.sent();
                    _state.label = 3;
                case 3:
                    return [
                        3,
                        5
                    ];
                case 4:
                    error = _state.sent();
                    console.warn("Could not modify .gitignore. Maybe it doesn't exist?");
                    return [
                        3,
                        5
                    ];
                case 5:
                    return [
                        2
                    ];
            }
        });
    });
    return _modifyGitignore.apply(this, arguments);
}
