import { z } from "zod";
import { BaseRequestHandler } from "./base-request-handler";
import { EmptyZodObject, RequestHandler, RouteParamsBase } from "./handler-types";
import { UseFinishRequest } from "./use-finish-request";
export declare class FullRequestHandler<RouteParams extends RouteParamsBase = object, QueryParams extends z.SomeZodObject = EmptyZodObject, Cookies extends z.SomeZodObject = EmptyZodObject, Body extends z.SomeZodObject = EmptyZodObject, InputContext extends object = object, OutputContext extends object = object> extends UseFinishRequest<RouteParams, QueryParams, Cookies, Body, InputContext, OutputContext> {
    private baseHandler;
    private contextFunction;
    getBaseHandler(): BaseRequestHandler<RouteParams, QueryParams, Cookies, Body>;
    getContextFunction(): RequestHandler<RouteParams, z.TypeOf<QueryParams>, z.TypeOf<Cookies>, z.TypeOf<Body>, InputContext, OutputContext>;
    constructor(baseHandler: BaseRequestHandler<RouteParams, QueryParams, Cookies, Body>, contextFunction: RequestHandler<RouteParams, z.TypeOf<QueryParams>, z.TypeOf<Cookies>, z.TypeOf<Body>, InputContext, OutputContext>);
}
