import { RequestMethod } from "./typed-api";
type Segment = {
    type: "static" | "param" | "catchAll" | "group";
    value: string;
};
type Route = {
    path: string;
    segment: Segment;
    children: Route[];
    parent: Route | null;
    hasHandler?: boolean;
};
export declare function parseDir(dir: string, parent: Route | null, initialSegment?: Segment): Promise<Route | null>;
export type ApiPath = {
    filepath: string;
    url: string;
    methods: Record<RequestMethod, boolean>;
    params: Record<string, "string" | "array">;
};
export declare function getApiPaths(route: Route): Promise<ApiPath[]>;
export declare const dynamicSegmentRegex: RegExp;
export declare const isDynamicSegment: (segment: string) => boolean;
export declare const catchAllSegmentRegex: RegExp;
export declare const isCatchAllSegment: (segment: string) => boolean;
export declare const routeGroupSegmentRegex: RegExp;
export declare const isRouteGroupSegment: (segment: string) => boolean;
export {};
