import { z } from "zod";
import { BaseRequestHandler } from "./base-request-handler";
import type { FullRequestHandler } from "./full-request-handler";
import { ContextBase, RequestHandler, RouteParamsBase } from "./handler-types";
import { Expand, MergeTypes, MergeZodObjects, TripleMerge, ZodObjectsDontConflict } from "./type-helpers";
export declare abstract class UseContext<RouteParams extends RouteParamsBase, QueryParams extends z.SomeZodObject, Cookies extends z.SomeZodObject, Body extends z.SomeZodObject, InputContext extends ContextBase, OutputContext extends ContextBase> {
    protected constructor();
    protected abstract getBaseHandler(): BaseRequestHandler<RouteParams, QueryParams, Cookies, Body>;
    protected abstract getContextFunction(): RequestHandler<RouteParams, z.TypeOf<QueryParams>, z.TypeOf<Cookies>, z.TypeOf<Body>, InputContext, OutputContext>;
    private useFn;
    private useFullApi;
    use<Out extends ContextBase>(fn: RequestHandler<RouteParams, z.TypeOf<QueryParams>, z.TypeOf<Cookies>, z.TypeOf<Body>, MergeTypes<InputContext, OutputContext>, Out | undefined | void>): FullRequestHandler<RouteParams, QueryParams, Cookies, Body, InputContext, TripleMerge<InputContext, OutputContext, Out>>;
    use<Out extends ContextBase, RouteParams2 extends object, QueryParams2 extends z.AnyZodObject, Cookies2 extends z.AnyZodObject, Body2 extends z.AnyZodObject>(api: UseContext<RouteParams2, ZodObjectsDontConflict<QueryParams2, QueryParams>, ZodObjectsDontConflict<Cookies2, Cookies>, ZodObjectsDontConflict<Body2, Body>, MergeTypes<InputContext, OutputContext>, Out>): FullRequestHandler<Expand<RouteParams & RouteParams2>, MergeZodObjects<QueryParams, QueryParams2>, MergeZodObjects<Cookies, Cookies2>, MergeZodObjects<Body, Body2>, InputContext, TripleMerge<InputContext, OutputContext, Out>>;
}
