"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "UseFinishRequest", {
    enumerable: true,
    get: function() {
        return UseFinishRequest;
    }
});
var _server = require("next/server");
var _errors = require("./errors");
var _usecontext = require("./use-context");
function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _array_without_holes(arr) {
    if (Array.isArray(arr)) return _array_like_to_array(arr);
}
function _assert_this_initialized(self) {
    if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
    }
    return self;
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
    try {
        var info = gen[key](arg);
        var value = info.value;
    } catch (error) {
        reject(error);
        return;
    }
    if (info.done) {
        resolve(value);
    } else {
        Promise.resolve(value).then(_next, _throw);
    }
}
function _async_to_generator(fn) {
    return function() {
        var self = this, args = arguments;
        return new Promise(function(resolve, reject) {
            var gen = fn.apply(self, args);
            function _next(value) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
            }
            function _throw(err) {
                asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
            }
            _next(undefined);
        });
    };
}
function _class_call_check(instance, Constructor) {
    if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
    }
}
function _defineProperties(target, props) {
    for(var i = 0; i < props.length; i++){
        var descriptor = props[i];
        descriptor.enumerable = descriptor.enumerable || false;
        descriptor.configurable = true;
        if ("value" in descriptor) descriptor.writable = true;
        Object.defineProperty(target, descriptor.key, descriptor);
    }
}
function _create_class(Constructor, protoProps, staticProps) {
    if (protoProps) _defineProperties(Constructor.prototype, protoProps);
    if (staticProps) _defineProperties(Constructor, staticProps);
    return Constructor;
}
function _get_prototype_of(o) {
    _get_prototype_of = Object.setPrototypeOf ? Object.getPrototypeOf : function getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
    };
    return _get_prototype_of(o);
}
function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
    }
    subClass.prototype = Object.create(superClass && superClass.prototype, {
        constructor: {
            value: subClass,
            writable: true,
            configurable: true
        }
    });
    if (superClass) _set_prototype_of(subClass, superClass);
}
function _instanceof(left, right) {
    if (right != null && typeof Symbol !== "undefined" && right[Symbol.hasInstance]) {
        return !!right[Symbol.hasInstance](left);
    } else {
        return left instanceof right;
    }
}
function _iterable_to_array(iter) {
    if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _non_iterable_spread() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _possible_constructor_return(self, call) {
    if (call && (_type_of(call) === "object" || typeof call === "function")) {
        return call;
    }
    return _assert_this_initialized(self);
}
function _set_prototype_of(o, p) {
    _set_prototype_of = Object.setPrototypeOf || function setPrototypeOf(o, p) {
        o.__proto__ = p;
        return o;
    };
    return _set_prototype_of(o, p);
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _to_consumable_array(arr) {
    return _array_without_holes(arr) || _iterable_to_array(arr) || _unsupported_iterable_to_array(arr) || _non_iterable_spread();
}
function _type_of(obj) {
    "@swc/helpers - typeof";
    return obj && typeof Symbol !== "undefined" && obj.constructor === Symbol ? "symbol" : typeof obj;
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
function _is_native_reflect_construct() {
    if (typeof Reflect === "undefined" || !Reflect.construct) return false;
    if (Reflect.construct.sham) return false;
    if (typeof Proxy === "function") return true;
    try {
        Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function() {}));
        return true;
    } catch (e) {
        return false;
    }
}
function _create_super(Derived) {
    var hasNativeReflectConstruct = _is_native_reflect_construct();
    return function _createSuperInternal() {
        var Super = _get_prototype_of(Derived), result;
        if (hasNativeReflectConstruct) {
            var NewTarget = _get_prototype_of(this).constructor;
            result = Reflect.construct(Super, arguments, NewTarget);
        } else {
            result = Super.apply(this, arguments);
        }
        return _possible_constructor_return(this, result);
    };
}
function _ts_generator(thisArg, body) {
    var f, y, t, g, _ = {
        label: 0,
        sent: function() {
            if (t[0] & 1) throw t[1];
            return t[1];
        },
        trys: [],
        ops: []
    };
    return(g = {
        next: verb(0),
        "throw": verb(1),
        "return": verb(2)
    }, typeof Symbol === "function" && (g[Symbol.iterator] = function() {
        return this;
    }), g);
    function verb(n) {
        return function(v) {
            return step([
                n,
                v
            ]);
        };
    }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while(_)try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [
                op[0] & 2,
                t.value
            ];
            switch(op[0]){
                case 0:
                case 1:
                    t = op;
                    break;
                case 4:
                    _.label++;
                    return {
                        value: op[1],
                        done: false
                    };
                case 5:
                    _.label++;
                    y = op[1];
                    op = [
                        0
                    ];
                    continue;
                case 7:
                    op = _.ops.pop();
                    _.trys.pop();
                    continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                        _ = 0;
                        continue;
                    }
                    if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
                        _.label = op[1];
                        break;
                    }
                    if (op[0] === 6 && _.label < t[1]) {
                        _.label = t[1];
                        t = op;
                        break;
                    }
                    if (t && _.label < t[2]) {
                        _.label = t[2];
                        _.ops.push(op);
                        break;
                    }
                    if (t[2]) _.ops.pop();
                    _.trys.pop();
                    continue;
            }
            op = body.call(thisArg, _);
        } catch (e) {
            op = [
                6,
                e
            ];
            y = 0;
        } finally{
            f = t = 0;
        }
        if (op[0] & 5) throw op[1];
        return {
            value: op[0] ? op[1] : void 0,
            done: true
        };
    }
}
var UseFinishRequest = /*#__PURE__*/ function(UseContext) {
    "use strict";
    _inherits(UseFinishRequest, UseContext);
    var _super = _create_super(UseFinishRequest);
    function UseFinishRequest() {
        _class_call_check(this, UseFinishRequest);
        return _super.call(this);
    }
    _create_class(UseFinishRequest, [
        {
            key: "finish",
            value: function finish(method, handler) {
                var _this = this;
                var realHandler = function() {
                    var _ref = _async_to_generator(function(req, param) {
                        var rawParams, _this_getBaseHandler_parseRequest, body, query, cookies, params, headers, cookiesMap, res, realBody, context, error, _error_message, _ref, errorMessage, response, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, _step_value, key, value, _iteratorNormalCompletion1, _didIteratorError1, _iteratorError1, _iterator1, _step1, cookie, _response_cookies, _response_cookies1;
                        function setCookie() {
                            for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++){
                                args[_key] = arguments[_key];
                            }
                            var key = typeof args[0] === "string" ? args[0] : args[0].name;
                            cookiesMap.set(key, {
                                type: "set",
                                set: args
                            });
                        }
                        function deleteCookie() {
                            for(var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++){
                                args[_key] = arguments[_key];
                            }
                            var key = typeof args[0] === "string" ? args[0] : args[0].name;
                            if (cookiesMap.has(key)) {
                                cookiesMap.delete(key);
                            }
                            cookiesMap.set(key, {
                                type: "delete",
                                delete: args
                            });
                        }
                        return _ts_generator(this, function(_state) {
                            switch(_state.label){
                                case 0:
                                    rawParams = param.params;
                                    _this_getBaseHandler_parseRequest = _this.getBaseHandler().parseRequest(req, {
                                        params: rawParams
                                    }), body = _this_getBaseHandler_parseRequest.body, query = _this_getBaseHandler_parseRequest.query, cookies = _this_getBaseHandler_parseRequest.cookies, params = _this_getBaseHandler_parseRequest.params;
                                    headers = new Headers();
                                    cookiesMap = new Map();
                                    _state.label = 1;
                                case 1:
                                    _state.trys.push([
                                        1,
                                        6,
                                        ,
                                        7
                                    ]);
                                    realBody = body;
                                    return [
                                        4,
                                        _this.getContextFunction()({
                                            params: params,
                                            query: query,
                                            cookies: cookies,
                                            body: body,
                                            context: {},
                                            req: req,
                                            setCookie: setCookie,
                                            deleteCookie: deleteCookie,
                                            headers: headers
                                        })
                                    ];
                                case 2:
                                    context = _state.sent();
                                    if (!_instanceof(context, _server.NextResponse)) return [
                                        3,
                                        3
                                    ];
                                    res = context;
                                    return [
                                        3,
                                        5
                                    ];
                                case 3:
                                    return [
                                        4,
                                        handler({
                                            params: params,
                                            query: query,
                                            cookies: cookies,
                                            body: realBody,
                                            context: context,
                                            req: req,
                                            setCookie: setCookie,
                                            deleteCookie: deleteCookie,
                                            headers: headers
                                        })
                                    ];
                                case 4:
                                    res = _state.sent();
                                    _state.label = 5;
                                case 5:
                                    return [
                                        3,
                                        7
                                    ];
                                case 6:
                                    error = _state.sent();
                                    if (_instanceof(error, _errors.RedirectError)) {
                                        res = _server.NextResponse.redirect(error.url, error.statusCode);
                                    }
                                    errorMessage = (_ref = (_error_message = error.message) !== null && _error_message !== void 0 ? _error_message : error) !== null && _ref !== void 0 ? _ref : "Unknown error";
                                    res = getJsonResponse({
                                        status: "error",
                                        message: errorMessage
                                    });
                                    return [
                                        3,
                                        7
                                    ];
                                case 7:
                                    response = _instanceof(res, _server.NextResponse) ? res : getJsonResponse({
                                        status: "ok",
                                        data: res
                                    });
                                    _iteratorNormalCompletion = true, _didIteratorError = false, _iteratorError = undefined;
                                    try {
                                        for(_iterator = headers.entries()[Symbol.iterator](); !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true){
                                            _step_value = _sliced_to_array(_step.value, 2), key = _step_value[0], value = _step_value[1];
                                            response.headers.set(key, value);
                                        }
                                    } catch (err) {
                                        _didIteratorError = true;
                                        _iteratorError = err;
                                    } finally{
                                        try {
                                            if (!_iteratorNormalCompletion && _iterator.return != null) {
                                                _iterator.return();
                                            }
                                        } finally{
                                            if (_didIteratorError) {
                                                throw _iteratorError;
                                            }
                                        }
                                    }
                                    _iteratorNormalCompletion1 = true, _didIteratorError1 = false, _iteratorError1 = undefined;
                                    try {
                                        for(_iterator1 = cookies.values()[Symbol.iterator](); !(_iteratorNormalCompletion1 = (_step1 = _iterator1.next()).done); _iteratorNormalCompletion1 = true){
                                            cookie = _step1.value;
                                            if (cookie.type === "set") {
                                                ;
                                                (_response_cookies = response.cookies).set.apply(_response_cookies, _to_consumable_array(cookie.set));
                                            } else {
                                                ;
                                                (_response_cookies1 = response.cookies).delete.apply(_response_cookies1, _to_consumable_array(cookie.delete));
                                            }
                                        }
                                    } catch (err) {
                                        _didIteratorError1 = true;
                                        _iteratorError1 = err;
                                    } finally{
                                        try {
                                            if (!_iteratorNormalCompletion1 && _iterator1.return != null) {
                                                _iterator1.return();
                                            }
                                        } finally{
                                            if (_didIteratorError1) {
                                                throw _iteratorError1;
                                            }
                                        }
                                    }
                                    return [
                                        2,
                                        response
                                    ];
                            }
                        });
                    });
                    return function realHandler(req, _) {
                        return _ref.apply(this, arguments);
                    };
                }();
                return realHandler;
            }
        },
        {
            key: "get",
            value: function get(handler) {
                return this.finish("GET", handler);
            }
        },
        {
            key: "post",
            value: function post(handler) {
                return this.finish("POST", handler);
            }
        },
        {
            key: "put",
            value: function put(handler) {
                return this.finish("PUT", handler);
            }
        },
        {
            key: "patch",
            value: function patch(handler) {
                return this.finish("PATCH", handler);
            }
        },
        {
            key: "delete",
            value: function _delete(handler) {
                return this.finish("DELETE", handler);
            }
        },
        {
            key: "head",
            value: function head(handler) {
                return this.finish("HEAD", handler);
            }
        },
        {
            key: "options",
            value: function options(handler) {
                return this.finish("OPTIONS", handler);
            }
        }
    ]);
    return UseFinishRequest;
}(_usecontext.UseContext);
function getJsonResponse(data) {
    return _server.NextResponse.json(data);
}
